"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OperatorSubscriber = void 0;
const rxjs_1 = require("rxjs");
const defaultComplete = rxjs_1.Subscriber.prototype._complete;
const defaultError = rxjs_1.Subscriber.prototype._error;
const defaultNext = rxjs_1.Subscriber.prototype._next;
class OperatorSubscriber extends rxjs_1.Subscriber {
    constructor(destination, handlers) {
        super(destination);
        const { complete, error, next } = handlers;
        this._complete = complete
            ? () => {
                try {
                    complete();
                }
                catch (caught) {
                    destination.error(caught);
                }
                this.unsubscribe();
            }
            : defaultComplete;
        this._error = error
            ? (received) => {
                try {
                    error(received);
                }
                catch (caught) {
                    destination.error(caught);
                }
                this.unsubscribe();
            }
            : defaultError;
        this._next = next
            ? (value) => {
                try {
                    next(value);
                }
                catch (caught) {
                    destination.error(caught);
                }
            }
            : defaultNext;
    }
}
exports.OperatorSubscriber = OperatorSubscriber;
//# sourceMappingURL=OperatorSubscriber.js.map