"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.percolate = void 0;
const rxjs_1 = require("rxjs");
function percolate(...sources) {
    const [first, ...remainder] = sources;
    if (sources.length === 1 && Array.isArray(first)) {
        return percolate(...first);
    }
    return new rxjs_1.Observable((subscriber) => {
        const subNext = (err) => {
            if (remainder.length === 0) {
                subscriber.error(err);
            }
            else {
                subscriber.add(percolate(...remainder).subscribe(subscriber));
            }
        };
        return rxjs_1.from(first).subscribe({
            complete: () => {
                subscriber.complete();
            },
            next(value) {
                subscriber.next(value);
            },
            error: subNext,
        });
    });
}
exports.percolate = percolate;
//# sourceMappingURL=percolate.js.map